#define vtkRenderingCore_AUTOINIT 4(vtkInteractionStyle,vtkRenderingFreeType,vtkRenderingFreeTypeOpenGL,vtkRenderingOpenGL) 
#define vtkRenderingVolume_AUTOINIT 1(vtkRenderingVolumeOpenGL) 

#include "cpa_findley.h"
#include "calculation.h"

// This is included here because it is forward declared in
// RenderWindowUISingleInheritance.h 
#include "ui_render_enklere_navn.h"

#include <vtkArrowSource.h>
#include <stdlib.h>
#include <vtkPolyDataMapper.h>
#include <vtkAxesActor.h>
#include <vtkPolyData.h>
#include <vtkDataSet.h>
#include <vtkDataArray.h>
#include <vtkPoints.h>
#include <vtkPolyData.h>
#include <vtkPointData.h>
#include <vtkDoubleArray.h>
#include <vtkFloatArray.h>
#include <vtkTextActor.h>
#include <vtkTextProperty.h>
#include <vtkDataSetAttributes.h>
#include <vtkDataSetMapper.h>
#include <vtkPolyDataAlgorithm.h>
#include <vtkRenderer.h>
#include <vtkProperty.h>
#include <vtkPoints.h>
#include <vtkRenderWindow.h>
#include <vtkSphereSource.h>
#include <vtkCellArray.h>
#include <vtkSmartPointer.h>
#include <vtkUnsignedCharArray.h>
#include <vtkGlyph3D.h> 
#include <vtkFloatArray.h>
#include <vtkOrientationMarkerWidget.h>
#include <vtkTransform.h>
#include <vtkCellLocator.h>
#include <vtkKdTreePointLocator.h>
#include <vtkLineSource.h>
#include <stdio.h>
#include <string>
#include <sstream>
#include <vtkPlaneSource.h>
#include <vtkCubeSource.h>
#include <vtkScalarBarActor.h>
#include <vtkExtractEdges.h>
#include <vtkLookupTable.h>
#include <Eigen/Dense>

using Eigen::MatrixXf;
using namespace std;

std::string convertInt(int number);

// Constructor
Render_enklere_navn::Render_enklere_navn() 
{

	MatrixXd stressTensorsAll;

	stressTensorsAll = doCalculation(1);

	double min = 0.0;
	double max = 0.0;
	double tempMax = 0.0; 
	double tempMin = 0.0;

	for(int i=0; i<stressTensorsAll.innerSize(); i++){
		if(i==0){
			min = stressTensorsAll(i,0);
			max = stressTensorsAll(i,0);
		}
		if(stressTensorsAll(i,0) > tempMax){
			max = stressTensorsAll(i,0);
			tempMax = max;
		}
		if(stressTensorsAll(i,0) < tempMin){
			min = stressTensorsAll(i,0);
			tempMin = min;
		}
	}


	ofstream myfile ("example.txt");
  if (myfile.is_open())
  {
	  for(int wR=0; wR<stressTensorsAll.innerSize(); wR++){
		  myfile << stressTensorsAll(wR,0);
			myfile << "\n";
		}

	myfile << "min: " << min << "\n";
	myfile << "max: " << max << "\n";
	myfile.close();
  }

	this->ui = new Ui_Render_enklere_navn;
	this->ui->setupUi(this);


    // Create a sphere
	vtkSmartPointer<vtkSphereSource> sphere = vtkSmartPointer<vtkSphereSource>::New();
	sphere->SetCenter(0,0,0);
	sphere->SetThetaResolution(38);
	sphere->SetPhiResolution(38);
	sphere->SetRadius(1);
	sphere->Update();



 
	// Create scalar data to associate with the vertices of the sphere
	int numPts = sphere->GetOutput()->GetPoints()->GetNumberOfPoints();


	MatrixXf sigmaXvalues(1, numPts);
	for(int j=0; j<numPts; j++){
	  sigmaXvalues(0, j) = stressTensorsAll(j,0);

	}

	vtkSmartPointer<vtkFloatArray> scalars = vtkSmartPointer<vtkFloatArray>::New();
	scalars->SetNumberOfValues( numPts );
	
	for( int i = 0; i < numPts; ++i )
	{
		scalars->SetValue(i,sigmaXvalues(0,i));
    }
	vtkSmartPointer<vtkPolyData> poly = vtkSmartPointer<vtkPolyData>::New();
	poly->DeepCopy(sphere->GetOutput());
	poly->GetPointData()->SetScalars(scalars);
 
	vtkSmartPointer<vtkPolyDataMapper> mapper = vtkSmartPointer<vtkPolyDataMapper>::New();
#if VTK_MAJOR_VERSION <= 5
  mapper->SetInput(poly);
#else
  mapper->SetInputData(poly);
#endif
	 mapper->ScalarVisibilityOn();
	 mapper->SetScalarRange(min,max);
	mapper->SetScalarModeToUsePointData();
	mapper->SetColorModeToMapScalars();
 
	vtkSmartPointer<vtkActor> actor = vtkSmartPointer<vtkActor>::New();
	actor->SetMapper(mapper);
 
	vtkSmartPointer<vtkScalarBarActor> scalarBar = vtkSmartPointer<vtkScalarBarActor>::New();
	scalarBar->SetLookupTable(mapper->GetLookupTable());
	scalarBar->SetTitle("Mpa");
	scalarBar->SetNumberOfLabels(4);
 
	// Create a lookup table to share between the mapper and the scalarbar
	vtkSmartPointer<vtkLookupTable> hueLut = vtkSmartPointer<vtkLookupTable>::New();
	hueLut->SetTableRange (min, max);
	hueLut->SetHueRange (0, 1);
	hueLut->SetSaturationRange (1, 1);
	hueLut->SetValueRange (1, 1);
	hueLut->Build();
 
	mapper->SetLookupTable( hueLut );
	scalarBar->SetLookupTable( hueLut );

  	vtkSmartPointer<vtkCubeSource> box = vtkSmartPointer<vtkCubeSource>::New();
	box->SetXLength(2);
	box->SetYLength(2);
	box->SetZLength(2);

    vtkSmartPointer<vtkExtractEdges> edges = vtkSmartPointer<vtkExtractEdges>::New();
    edges->SetInputConnection(box->GetOutputPort());

    vtkSmartPointer<vtkPolyDataMapper> cubeMapper = vtkSmartPointer<vtkPolyDataMapper>::New();
    cubeMapper->SetInputConnection(edges->GetOutputPort());

    vtkSmartPointer<vtkActor> cubeEdgeActor = vtkSmartPointer<vtkActor>::New();
    cubeEdgeActor->SetMapper(cubeMapper);
    cubeEdgeActor->GetProperty()->SetColor(0,0,0);  
    cubeEdgeActor->GetProperty()->SetAmbient(1);


	vtkSmartPointer<vtkPlaneSource> planeSource = vtkSmartPointer<vtkPlaneSource>::New(); 
	planeSource-> SetNormal(-tan(1.5708),-tan(2.094),1.0); 
	//planeSource-> SetOrigin(3.0, 0.0, 0.0);
	planeSource-> SetPoint1(3.0, 0.0, 0.0 );
	planeSource-> SetPoint2(0.0, 3.0, 0.0 );
	planeSource->SetCenter(0,0,0);
	planeSource-> SetXResolution(10);
	planeSource-> SetYResolution(10);
	planeSource-> Update(); 

	// Create a mapper and actor. 
	vtkSmartPointer<vtkPolyDataMapper> planeSourceMapper = vtkSmartPointer<vtkPolyDataMapper>::New(); 
	planeSourceMapper->SetInputData(planeSource->GetOutput()); 

	vtkSmartPointer<vtkActor> planeSourceActor = vtkSmartPointer<vtkActor>::New(); 
	planeSourceActor->SetMapper(planeSourceMapper); 
	planeSourceActor->GetProperty()->SetColor(0.5, 0.3, 0.5);
	planeSourceActor->GetProperty()->SetOpacity(0.5);

	vtkSmartPointer<vtkTransform> transform = vtkSmartPointer<vtkTransform>::New();
	transform->Translate(-1.5, -1.5, -1.5);
 
	vtkSmartPointer<vtkAxesActor> axes = vtkSmartPointer<vtkAxesActor>::New();
 
	// The axes are positioned with a user transform
	axes->SetUserTransform(transform);
	axes->SetTotalLength(0.5, 0.5, 0.5);

	//Number of points on the sphere
	int numberofpoints = (int) sphere->GetOutput()->GetNumberOfPoints();
   
	std::string numb = convertInt(min); //stressTensorsAll.outerSize() 
	const char * c = numb.c_str();

	vtkSmartPointer<vtkTextActor> textActor = vtkSmartPointer<vtkTextActor>::New();
	textActor->GetTextProperty()->SetFontSize ( 24 );
	textActor->SetPosition2 ( 5, 30 );
	textActor->SetInput(c);
	textActor->GetTextProperty()->SetColor ( 1.0,0.0,0.0 );
	

  // Create a renderer and render window
 // vtkSmartPointer<vtkRenderer> renderer = 
 //   vtkSmartPointer<vtkRenderer>::New();

 
//  vtkSmartPointer<vtkRenderWindow> renderWindow = 
 //   vtkSmartPointer<vtkRenderWindow>::New();
 // renderWindow->AddRenderer(renderer);
 
  // Create an interactor
  //vtkSmartPointer<vtkRenderWindowInteractor> renderWindowInteractor = 
  //  vtkSmartPointer<vtkRenderWindowInteractor>::New();
 // renderWindowInteractor->SetRenderWindow(renderWindow);
 
  // Add the actors to the scene

  // Render the scene (lights and cameras are created automatically)
//  renderWindow->Render();
 // renderWindowInteractor->Start();





/*
    float low = render_settings.GetProperty("low").GetFloat();
    float high = render_settings.GetProperty("high").GetFloat();
    float r,g,b,low_hue,low_sat,low_val,high_hue,high_sat,high_val;
    render_settings.GetProperty("color_low").GetColor(r,g,b);
    vtkMath::RGBToHSV(r,g,b,&low_hue,&low_sat,&low_val);
    render_settings.GetProperty("color_high").GetColor(r,g,b);
    vtkMath::RGBToHSV(r,g,b,&high_hue,&high_sat,&high_val);


	
    // create a lookup table for mapping values to colors
    vtkSmartPointer<vtkLookupTable> lut = vtkSmartPointer<vtkLookupTable>::New();
    //lut->SetRampToLinear();
    //lut->SetScaleToLinear();
    lut->SetHueRange(0.0,0.667);
	lut->Build();


  ////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////**Sphere**///////////////////////////////////////////////
  ////////////////////////////////////////////////////////////////////////////////////
  /*
  vtkSmartPointer<vtkSphereSource> sphereSource = vtkSmartPointer<vtkSphereSource>::New();
	
	sphereSource->SetThetaResolution(120);
	sphereSource->SetPhiResolution(80);
	sphereSource->SetRadius(1);

	sphereSource->Update();

	//Number of points on the sphere
	int numberofpoints = (int) sphereSource->GetOutput()->GetNumberOfPoints();
   
	std::string numb = convertInt(numberofpoints);
	const char * c = numb.c_str();

	//Number of cells on the sphere
	int numberofcells = (int) sphereSource->GetOutput()->GetNumberOfCells();
   
	std::string numb2 = convertInt(numberofcells);
	const char * c2 = numb2.c_str();

	//vtkSmartPointer<vtkPolyDataMapper> sphereMapper = vtkSmartPointer<vtkPolyDataMapper>::New();
	//sphereMapper->SetInputConnection(sphereSource->GetOutputPort());


	// The locator used for finding the point on the sphere closest to a point in space
	vtkSmartPointer<vtkKdTreePointLocator> kDTree = vtkSmartPointer<vtkKdTreePointLocator>::New();
	
	kDTree->SetDataSet(sphereSource->GetOutput());
	kDTree->BuildLocator();

	//Just a test point - The end point of the vector
	double testPoint[3] = {1.0, 0.1, 0.8};
 
	 // Find the ID of the closest point on the sphere to the TestPoint
	vtkIdType iD = kDTree->FindClosestPoint(testPoint);
	//Get the coordinates of the closest point
	double closestPoint[3];
	kDTree->GetDataSet()->GetPoint(iD, closestPoint);

	//Print the id of the closest point
	int PiD = (int) iD;
	std::string numbCellId = convertInt(PiD);
	const char * c3 = numbCellId.c_str();

	//Coloring the sphere and the specific point
    vtkSmartPointer<vtkFloatArray> fa = vtkSmartPointer<vtkFloatArray>::New();
    fa->SetNumberOfValues (numberofpoints);
	for (int j=0; j < numberofpoints; j++){
		fa->SetValue ((vtkIdType) j, (float) 80);    // values[] is an array offloats in the range 0..100
		if(j==PiD)
			fa->SetValue((vtkIdType) j,(float) 2);
	}


	sphereSource->GetOutput()->GetPointData()->SetScalars(fa);

	// DataMapper for the sphereSource
	vtkSmartPointer<vtkPolyDataMapper> m = vtkSmartPointer<vtkPolyDataMapper>::New();
	m->SetInputConnection(sphereSource->GetOutputPort());
    m->SetScalarRange (0, 100);
    m->ScalarVisibilityOn();
    m->SetScalarModeToUsePointData();
    m->SetColorModeToMapScalars();

	// Just a startpoint for a vector
	double startpoint[3] = {0.0 , 0.0, 0.0};

    //Create a line.
	vtkSmartPointer<vtkLineSource> lineSource = vtkSmartPointer<vtkLineSource>::New();
	
	lineSource->SetPoint1(startpoint);
	lineSource->SetPoint2(testPoint);
	lineSource->Update();

	// Visualize the line
	vtkSmartPointer<vtkPolyDataMapper> linemapper = vtkSmartPointer<vtkPolyDataMapper>::New();
	linemapper->SetInputConnection(lineSource->GetOutputPort());
	
	//An actor for the line
	vtkSmartPointer<vtkActor> lineactor = vtkSmartPointer<vtkActor>::New();
	lineactor->SetMapper(linemapper);
	lineactor->GetProperty()->SetLineWidth(2);
	lineactor->GetProperty()->SetColor(1.0, 0.0, 0.0);

	vtkSmartPointer<vtkPlaneSource> planeSource = vtkSmartPointer<vtkPlaneSource>::New(); 
	planeSource-> SetNormal(-tan(1.5708),-tan(2.094),1.0); 
	//planeSource-> SetOrigin(3.0, 0.0, 0.0);
	planeSource-> SetPoint1(3.0, 0.0, 0.0 );
	planeSource-> SetPoint2(0.0, 3.0, 0.0 );
	planeSource->SetCenter(0,0,0);
	planeSource-> SetXResolution(10);
	planeSource-> SetYResolution(10);
	planeSource-> Update(); 

	// Create a mapper and actor. 
	vtkSmartPointer<vtkPolyDataMapper> planeSourceMapper = vtkSmartPointer<vtkPolyDataMapper>::New(); 
	planeSourceMapper->SetInputData(planeSource->GetOutput()); 

	vtkSmartPointer<vtkActor> planeSourceActor = vtkSmartPointer<vtkActor>::New(); 
	planeSourceActor->SetMapper(planeSourceMapper); 
	planeSourceActor->GetProperty()->SetColor(0.5, 0.3, 0.5);

	/* cube
	vtkSmartPointer<vtkCubeSource> surrCubeSource = vtkSmartPointer<vtkCubeSource>::New();
	surrCubeSource->SetXLength(2);
	surrCubeSource->SetYLength(2);
	surrCubeSource->SetZLength(2);

	vtkSmartPointer<vtkPolyDataMapper> cubeSourceMapper = vtkSmartPointer<vtkPolyDataMapper>::New();
	cubeSourceMapper->SetInputConnection(surrCubeSource->GetOutputPort());
	vtkSmartPointer<vtkActor> cubeSourceActor = vtkSmartPointer<vtkActor>::New(); 
	cubeSourceActor->SetMapper(cubeSourceMapper);
	cubeSourceActor->GetProperty()->SetColor(0.0,1.0,1.0);
	cubeSourceActor->GetProperty()->SetOpacity(0.2);
	cubeSourceActor->GetProperty()->EdgeVisibilityOn();

	
	    vtkSmartPointer<vtkCubeSource> box = vtkSmartPointer<vtkCubeSource>::New();
		box->SetXLength(2);
		box->SetYLength(2);
		box->SetZLength(2);

        vtkSmartPointer<vtkExtractEdges> edges = vtkSmartPointer<vtkExtractEdges>::New();
        edges->SetInputConnection(box->GetOutputPort());

        vtkSmartPointer<vtkPolyDataMapper> mapper = vtkSmartPointer<vtkPolyDataMapper>::New();
        mapper->SetInputConnection(edges->GetOutputPort());

        vtkSmartPointer<vtkActor> cubeEdgeActor = vtkSmartPointer<vtkActor>::New();
        cubeEdgeActor->SetMapper(mapper);
        cubeEdgeActor->GetProperty()->SetColor(0,0,0);  
        cubeEdgeActor->GetProperty()->SetAmbient(1);

	vtkSmartPointer<vtkActor> sphereActor = vtkSmartPointer<vtkActor>::New();
	sphereActor->SetMapper(m);
	//sphereActor->GetProperty()->SetOpacity(0.87);
	//sphereActor->GetProperty()->SetEdgeColor(1, 1, 1);
	//sphereActor->GetProperty()->EdgeVisibilityOn();
	sphereActor->GetProperty()->SetPointSize(4);

   vtkSmartPointer<vtkScalarBarActor> scalar_bar = vtkSmartPointer<vtkScalarBarActor>::New();
    scalar_bar->SetLookupTable(lut);
   
   */
	
	// VTK Renderer
	vtkSmartPointer<vtkRenderer> renderer = vtkSmartPointer<vtkRenderer>::New();
	/*
    // Setup the text and add it to the window
	vtkSmartPointer<vtkTextActor> textActor = vtkSmartPointer<vtkTextActor>::New();
	textActor->GetTextProperty()->SetFontSize ( 24 );
	textActor->SetPosition2 ( 5, 30 );
	textActor->SetInput(c);
	textActor->GetTextProperty()->SetColor ( 1.0,0.0,0.0 );

    // Setup the text and add it to the window 2
	vtkSmartPointer<vtkTextActor> textActor2 = vtkSmartPointer<vtkTextActor>::New();
	textActor2->GetTextProperty()->SetFontSize ( 24 );
	textActor2->SetPosition(5, 20);
	textActor2->SetInput(c3);
	textActor2->GetTextProperty()->SetColor ( 1.0,0.0,0.0 );


	*/
 
	// VTK/Qt wedded
	this->ui->qvtkWidget->GetRenderWindow()->AddRenderer(renderer);

	renderer->GradientBackgroundOn();
	renderer->SetBackground(1,1,1);
	renderer->SetBackground2(0,0,0);
	renderer->AddActor(actor);
	renderer->AddActor(cubeEdgeActor);
	renderer->AddActor(axes);
	renderer->AddActor(planeSourceActor);
	renderer->AddActor2D(scalarBar);
	renderer->AddActor2D(textActor);
 

	// this->ui->qvtkWidget->GetRenderWindow()->AddRenderer(ren);
	/*
    vtkSmartPointer<vtkTransform> transform = vtkSmartPointer<vtkTransform>::New();
	transform->Translate(-1.5, -1.0, -1.0);
 
	vtkSmartPointer<vtkAxesActor> axes = vtkSmartPointer<vtkAxesActor>::New();
 
	// The axes are positioned with a user transform
	axes->SetUserTransform(transform);
	axes->SetTotalLength(0.5, 0.5, 0.5);
 
	// properties of the axes labels can be set as follows
	// this sets the x axis label to red
	// axes->GetXAxisCaptionActor2D()->GetCaptionTextProperty()->SetColor(1,0,0);
 
	// the actual text of the axis label can be changed:
	// axes->SetXAxisLabelText("test");
 
	renderer->AddActor(sphereActor);
	renderer->SetBackground(0.72, 0.72, 0.72);
	renderer->AddActor(planeSourceActor);
	renderer->AddActor(cubeEdgeActor);


	renderer->AddActor(axes);
	renderer->AddActor(lineactor);
	renderer->AddActor2D ( textActor2 );
	renderer->AddActor2D ( textActor );
	renderer->AddActor2D(scalar_bar);

	*/
	// Set up action signals and slots
	connect(this->ui->actionExit, SIGNAL(triggered()), this, SLOT(slotExit()));
 
}
 
void Render_enklere_navn::slotExit() 
{
  qApp->exit();
}

std::string convertInt(int number)
{
   std::stringstream ss;//create a stringstream
   ss << number;//add number to the stream
   return ss.str();//return a string with the contents of the stream
}



  /*************************************************************/
 /*****************PENSJONERTE DELER***************************/
/*************************************************************/


  /*vtkSmartPointer<vtkCellLocator> cellLocator = vtkSmartPointer<vtkCellLocator>::New();
  cellLocator->SetDataSet(sphereSource->GetOutput());
  cellLocator->BuildLocator();

  double testPoint[3] = {2.0, 2.0, 0.0};
 
  //Find the closest points to TestPoint
  double closestPoint[3];//the coordinates of the closest point will be returned here
  double closestPointDist2; //the squared distance to the closest point will be returned here
  vtkIdType cellId; //the cell id of the cell containing the closest point will be returned here
  int subId; //this is rarely used (in triangle strips only, I believe)
  cellLocator->FindClosestPoint(testPoint, closestPoint, cellId, subId, closestPointDist2);

  int cel = (int) cellId;
  std::string numbCellId = convertInt(cel);
   const char * c3 = numbCellId.c_str();
   */